#include "App.h"
#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include "RList.h"
#include "Player.h"
#include "Target.h"

#define MAXBUFLEN 2000000
App::App()
{
  isLethal=false;
  hack=true;
  playerList=new RList();
  targetList=new RList();
}

App::~App()
{
}

void App::Run()
{
  bool ok=true;
  while(ok){
    printf("*****************************************\n");
    PrintToStream();
    ok=SendReply();    
    ok=ReadServerReply();
  }
  close(sockfd);
}

bool App::Init(char* host, unsigned short port)
{
  
  int numbytes;
  
  if ((he=gethostbyname(host)) == NULL) {  // get the host info
    perror("gethostbyname");
    exit(1);
  }
  
  if ((sockfd = socket(AF_INET, SOCK_STREAM/*SOCK_DGRAM*/, 0)) == -1) {
    perror("socket");
    exit(1);
  }
  
  their_addr.sin_family = AF_INET;     // host byte order
  their_addr.sin_port = port; // short, network byte order
  their_addr.sin_addr = *((struct in_addr *)he->h_addr);
  memset(&(their_addr.sin_zero), '\0', 8);  // zero the rest of the struct
  if (connect(sockfd, (struct sockaddr *)&their_addr,
	      sizeof(struct sockaddr)) == -1) {
    perror("connect");
    exit(1);
  }
  
  char *message="Player\n";
  int size;
  size=strlen(message);
  if( (numbytes=sendto(sockfd, message, size, 0, (struct sockaddr *)&their_addr, 
		       sizeof(struct sockaddr))) == -1) 
    {
      perror("sendto");
      exit(1);
    }
  
  printf("sent %d bytes to %s:%d\n", numbytes, inet_ntoa(their_addr.sin_addr),port);
  
  

  char buf[MAXBUFLEN];
  struct sockaddr_in my_addr; 
  my_addr.sin_family = AF_INET;         // host byte order
  my_addr.sin_port =their_addr.sin_port ;     // short, network byte order
  my_addr.sin_addr.s_addr = INADDR_ANY; // automatically fill with my IP
  memset(&(my_addr.sin_zero), '\0', 8); // zero the rest of the struct
 
  bool read_ok=false;
  printf("receiving\n");
  socklen_t addr_len = sizeof(struct sockaddr);
  char line[2048];
  for(int i=0;i<200;i++){
    if ((numbytes=recvfrom(sockfd, buf, 1 ,0 ,
			 (struct sockaddr *)&their_addr, &addr_len)) == -1) {
      perror("recvfrom");
      exit(1);
    }
    line[i]=buf[0];
    if(buf[0]=='\n'){
      read_ok=true;
      break;
    }
  }
  if(!read_ok){
    printf("Unable to read first line\n");
    exit(0);
  }
  
  sscanf(line,"%d %d\n",&width,&height);
  printf("W:%d H:%d\n",width,height);

  // -------------------------------
  table=(char*)malloc(width*height);
  current_table=(char*)malloc(width*height);
  // Fill them....
  for(int i=0;i<width*height;i++){
    table[i]='+';
    current_table[i]='*';
  }

  for(int i=0;i<height;i++){

    if ((numbytes=recvfrom(sockfd, buf, width+1 , MSG_WAITALL,
			   (struct sockaddr *)&their_addr, &addr_len)) == -1) {
      perror("recvfrom");
      exit(1);
    }
    
    memcpy(table+i*width,buf,width);
  
  }

  
  if ((numbytes=recvfrom(sockfd, buf, MAXBUFLEN-1 ,0 ,
			   (struct sockaddr *)&their_addr, &addr_len)) == -1) {
      perror("recvfrom");
      exit(1);
    }
  buf[numbytes] = '\0';

    char *buffer=buf;
    // Init the table
 

    // Read a line
  /*
  sscanf(buffer,"%s",line);
  buffer+=strlen(line);
  printf("READ:'%s'\n",line);
  //

  sscanf(line,"%d\n",&width);

  sscanf(buffer,"%s",line);
  buffer+=strlen(line);
  printf("READ:'%s'\n",line);

  sscanf(line,"%d\n",&height);
  printf("W:%d H:%d\n",width,height);
  //00
  sscanf(buffer,"%s\n",line);
  buffer+=strlen(line)+1;

  */
 


  // Print
  for(int y=0;y<height;y++){
    for(int x=0;x<width;x++){
      
      printf("%c",table[x+y*width]);
    }
    printf("\n");
  }

  // readline
  sscanf(buffer,"%s",line);
  buffer+=strlen(line)+1;
  printf("READ:'%s'\n",line);
  //
  
  sscanf(line,"%d\n",&id);

  sscanf(buffer,"%s",line);
  buffer+=strlen(line)+1;
  printf("READ:'%s'\n",line);
  sscanf(line,"%d\n",&capacity);

  sscanf(buffer,"%s",line);
  buffer+=strlen(line)+1;
  printf("READ:'%s'\n",line);
  sscanf(line,"%d\n",&money);
  printf("Id:%d Capacity:%d Money:%d\n",id,capacity,money);

  sscanf(buffer,"%s\n",line);
  //printf("------------------------------------------------READ:'%s'\n",buffer);
  UpdateTable();
  return ParseServerReply(buffer,strlen(buffer));

}

bool App::ReadPackage()
{
  printf("*****ReadPackage()\n");
  //read
  char buf[MAXBUFLEN];
  socklen_t addr_len = sizeof(struct sockaddr);
  int numbytes;
  if ((numbytes=recvfrom(sockfd, buf, MAXBUFLEN-1 , 0,
			 (struct sockaddr *)&their_addr, &addr_len)) == -1) {
    perror("recvfrom");
    exit(1);
  }

  printf("got packet from %s\n",inet_ntoa(their_addr.sin_addr));
  printf("packet is %d bytes long\n",numbytes);
  buf[numbytes] = '\0';
  printf("packet contains \"%s\"\n",buf);
  return ParsePackage(buf,sizeof(numbytes));
}
bool App::SendReply()
{
  printf("******SendReply()\n");
  psychoKiller();

  if(targetList->CountItems()<1){
    FindTarget();
  }
  char message[30];
  bool ok=false;
  for(int i=0;i<targetList->CountItems();i++){
    ok=((Target*)targetList->ItemAt(0))->Action(message);
    if(ok){
      break;
    }else{
      targetList->RemoveItem(0);
      if(targetList->CountItems()<1){
	FindTarget();
      }
    }
  }
  if(!ok){
    sprintf(message,"1 Pick 2000\n");
  }
  printf("->>>>>>>>>>>>    %s",message);
  
 
  return Send(message,strlen(message));
}
bool App::Send(char *buffer, int length)
{
  printf("Send('%s',%d)\n",buffer,length);
  int numbytes;
  if( (numbytes=sendto(sockfd, buffer, length, 0, (struct sockaddr *)&their_addr, 
		       sizeof(struct sockaddr))) == -1) 
    {
      perror("sendto");
      exit(1);
    }
  
  printf("sent %d bytes to %s\n", numbytes, inet_ntoa(their_addr.sin_addr));
  
  
  return true;
}

bool App::ReadServerReply()
{
  printf("*****ReadServerReply()\n");
  //read
  char buf[MAXBUFLEN];
  socklen_t addr_len = sizeof(struct sockaddr);
  int numbytes;
  
  if ((numbytes=recvfrom(sockfd, buf, MAXBUFLEN-1 , 0,
			 (struct sockaddr *)&their_addr, &addr_len)) == -1) {
    perror("recvfrom");
    exit(1);
  }

  printf("got packet from %s\n",inet_ntoa(their_addr.sin_addr));
  printf("packet is %d bytes long\n",numbytes);
  buf[numbytes] = '\0';

  printf("------------------------------------------packet contains:%s\n",buf);
  printf("----------------------------------------------------------------\n");
  printf("Package scan\n");
  if(numbytes==1 && hack){
    hack=false;
    if ((numbytes=recvfrom(sockfd, buf, MAXBUFLEN-1 , 0,
			 (struct sockaddr *)&their_addr, &addr_len)) == -1) {
    perror("recvfrom");
    exit(1);
  }
  
  printf("got packet from %s\n",inet_ntoa(their_addr.sin_addr));
  printf("packet is %d bytes long\n",numbytes);
  buf[numbytes] = '\0';

  printf("------------------------------------------packet contains:%s\n",buf);
  printf("----------------------------------------------------------------\n");
  printf("Package rescaned!!!!!!!!!!\n");
    
  }
  int i;
  for( i=0;i<numbytes;i++){
    if(buf[i]=='\n'){
      break;
    }
  }
  
  ParseServerReply(buf,i);
 
    ParsePackage(buf+i,numbytes-i+1);
  //Parse
  return true;
}
bool App::ParseServerReply(char* buffer,int length)
{
  printf("ParseServerReply('%s'/%d)\n",buffer,length);
  char *t=buffer;
  char token[8];
  int index=0;
  int robot;
/*  if(index<length-1){
    printf("Scanning:'%s'\n",t+index);
    sscanf(t+index,"%s",token);
    index+=strlen(token)+1;
    printf("READ:'%s' (index=%d, length=%d)\n",token,index,length);
  
    if(token[0]==35){ 
      sscanf(token+1,"%d",&robot);
      printf("Robot%d\n",robot);
*/    
      while(index<length){
	printf("==Scanning:'%s'\n",t+index);
	sscanf(t+index,"%s",token);

	printf("==== READ:'%s'\n",token);
	if(token[0]=='N'){
	  printf("North read\n");
	  for(int i=0;i<playerList->CountItems();i++){
	    printf("i:%d/%d\n",i,playerList->CountItems());
	    Player *p=(Player*)(playerList->ItemAt(i));
	    if(p->id==robot)
	      p->MoveNorth();
	  }
	  index+=strlen(token)+1;
	  
	}else if(token[0]=='S'){
	  printf("South read\n");
	  for(int i=0;i<playerList->CountItems();i++){
	    printf("i:%d/%d\n",i,playerList->CountItems());
	    Player *p=(Player*)(playerList->ItemAt(i));
	    if(p->id==robot)
	      p->MoveSouth();
	  }
	  index+=strlen(token)+1;
	}else if(token[0]=='E'){
	  printf("East read\n");
	  for(int i=0;i<playerList->CountItems();i++){
	    printf("i:%d/%d\n",i,playerList->CountItems());
	    Player *p=(Player*)(playerList->ItemAt(i));
	    if(p->id==robot)
	      p->MoveEast();
	  }
	  index+=strlen(token)+1;
	}else if(token[0]=='W'){
	  printf("West read\n");
	  for(int i=0;i<playerList->CountItems();i++){
	    printf("i:%d/%d\n",i,playerList->CountItems());
	    Player *p=(Player*)(playerList->ItemAt(i));
	    if(p->id==robot)
	      p->MoveWest();
	  }
	  index+=strlen(token)+1;
	}else if(token[0]=='X'){
	  printf("X read\n");
	  int temp_x,temp_y;
	  printf("Scanning:'%s'\n",t+index);
	  sscanf(t+index,"X %d Y %d",&temp_x,&temp_y);
	  char t[50];
	  sprintf(t,"X %d Y %d ",temp_x,temp_y);
	  
	  index+=strlen(t);
	  printf(".......................................Robot: %d, X=%d , Y=%d read\n",robot,temp_x,temp_y);
	 
	  Player *p=new Player(robot,temp_x,temp_y);
	  playerList->AddItem(p);
	 
	}else if(token[0]=='D'){
	  printf("D read\n");
	  index+=strlen(token)+1;
	  int temp_id;
	  printf("Scanning:'%s'\n",t+index);
	  sscanf(t+index,"%d",&temp_id);
	  char t[50];
	  sprintf(t,"%d ",temp_id);
	  
	  index+=strlen(t);
	  printf("D:%d read\n",temp_id);
	  //targetList->RemoveItem(0);
	  
	}else if(token[0]=='P'){
	  printf("P read\n");
	  int temp_id;
	  index+=strlen(token)+1;
	  printf("Scanning:'%s'\n",t+index);
	  sscanf(t+index,"%d",&temp_id);
	  char t[50];
	  sprintf(t,"%d ",temp_id);
	  
	  index+=strlen(t);
	  printf("P:%d read\n",temp_id);
	  //targetList->RemoveItem(0);
	}else if(token[0]==35){ //#
	  sscanf(token+1,"%d",&robot);
	  printf("Robot%d\n",robot);
	 
	  index+=strlen(token)+1;
	  //char t[50];
	  //sprintf(t,"%d",robot);
	  
	  //index+=strlen(t);
	}
	else if(token[0]=='R'){
	  printf("Robot died\n");
	  exit(0);
	}else{
	  printf("Parse error, %c\n",token[0]);
	  
	  //exit(0);
	}
      
    

  } 

      printf("ParseServerReply Done--------------\n");
      UpdateTable();
  return true;
}

bool App::ParsePackage(char* buffer,int length){
  
  int pack_id[50];
  int pack_x[50];
  int pack_y[50];
  int pack_p[50];
  int pack_nb[50];
  int nb=0;
  printf("ParsePackage:'%s' /%d\n",buffer,length);
  if(length<=4){
    printf("No package here\n");
    return true;
  }
  else{
    char *t=buffer;
    char token[20];
    int index=0;
    int count=0; 
    while(index<length-1){
      int n;
      //printf("==Scanning:'%s'\n",t+index);
      sscanf(t+index,"%s",token);
      index+=strlen(token)+1;
      //printf("==== READ:'%s'\n",token);
      sscanf(token,"%d",&n);
      printf("==== NB:%d:  %d\n",count,n);
      if(count==0){
	pack_id[nb]=n;
      }else if(count==1){
	pack_x[nb]=n;
      }else if(count==2){
	pack_y[nb]=n;
      }else if(count==3){
	pack_p[nb]=n;nb++;
      }
      pack_nb[nb]=0;
      count++;
      
      if(nb>40){
	break;
      }
      count=count%4;
    }
  }
  
  for(int i=0;i<nb;i++){
    int xt,yt;
    xt=pack_x[i];
    yt=pack_y[i];
    for(int j=0;j<nb;j++){
      if(xt==pack_x[j] && yt==pack_y[j]){
	pack_nb[i]++;
      }
    }
  }
  for(int i=0;i<nb;i++){
    printf("Pack: %d (%d,%d) %d ,nb=%d\n",pack_id[i],pack_x[i],pack_y[i],pack_p[i],pack_nb[i]);
  }

  int min=0; int index_min=0; // pack the less 'max'
  int max=0; int index_max=0; // the max
  for(int i=0;i<nb;i++){
    if(pack_nb[i]>=max){
      index_max=i;max=pack_nb[i];
    }
    
  }
  for(int i=0;i<nb;i++){
  if(pack_nb[i]<max && pack_nb[i]>=min){
      index_min=i;
      min=pack_nb[i];
    }
  }
  printf("max:(%d/%d) min:(%d,%d)\n",max,index_max,min,index_min);
  if(index_min<index_max){
    int t;
    t=max;max=min;min=t;
    t=index_max;index_max=min;index_min=t;
  }
  // kil the max
  
  

  int cap=0;
  for(int i=0;i<nb;i++){
    if(pack_nb[i]==min){
      cap+=pack_p[i];
      if(cap>capacity){
	// too heavy!
	break;
      }

      Target *newTarget=new Target(PICK,currentPlayer->x,currentPlayer->y,pack_id[i]);
      if(!hasTarget(newTarget)){
	targetList->AddItem(newTarget);
      }      
    }
  }
  cap=0;
  for(int i=0;i<nb;i++){
    if(pack_nb[i]==min){
      cap+=pack_p[i];
      if(cap>capacity){
	// too heavy!
	break;
      }
     
      // take the min
      Target *newTarget;
      newTarget=new Target(GOTO,pack_x[i],pack_y[i],0);
      if(!hasTarget(newTarget)){
	targetList->AddItem(newTarget);
      }
      
      newTarget=new Target(DROP,pack_x[i],pack_y[i],pack_id[i]);
      if(!hasTarget(newTarget)){
	targetList->AddItem(newTarget);
      } 
      
    }
  }
  if(isLethal){
    targetList->AddItem(new Target(KILL,pack_x[index_max],pack_y[index_max],5));
  }
 return true;
}
void App::PrintToStream()
{
  printf("\nPlayers:\n");
  for(int i=0;i<playerList->CountItems();i++){
    //printf("i:%d/%d\n",i,playerList->CountItems());
    Player *p=(Player*)(playerList->ItemAt(i));
    p->PrintToStream();
  }
  printf("Task:\n");
    for(int i=0;i<targetList->CountItems();i++){
    Target *t=(Target*)(targetList->ItemAt(i));
    t->PrintToStream();
  }
  
  printf("Id:%d Capacity:%d Money:%d\n",id,capacity,money);
  for(int y=0;y<height;y++){
    /*for(int x=0;x<width;x++){
      printf("%c",table[x+y*width]);
    }
    printf("           ");*/
    for(int x=0;x<width;x++){
      printf("%c",current_table[x+y*width]);
    }
    printf("\n");
  }
  printf("******************\n");
}
void App::SetCurrent(int x,int y,char c){
  if(x>=0 && x<width && y>=0 && y<height){
    current_table[x+y*width]=c;
  }
}
void App::UpdateTable(){
  //Remove dead player
  for(int i=0;i<playerList->CountItems();i++){
    Player *p=(Player*)(playerList->ItemAt(i));
    if(table[(p->x-1)+width*(p->y-1)]=='~'){
      playerList->RemoveItem(p);
    } 
  }

  memcpy(current_table,table,width*height);
  for(int i=0;i<playerList->CountItems();i++){
    Player *p=(Player*)(playerList->ItemAt(i));
    char c;
    int x=p->x-1;
    int y=p->y-1;
    if(id==p->id){
      c='G';
    }else{
      c='0'+i%8;
    }
    SetCurrent(x,y,c);
    //top,bottom,right,left
    if(p->id!=id){
      SetCurrent(x-1,y,'+');
      SetCurrent(x+1,y,'+');
      SetCurrent(x,y-1,'+');
      SetCurrent(x,y+1,'+');
    }else{
      currentPlayer=p;
    }
  }
}

void App::FindTarget(){
  for(int y=0;y<height;y++){
    for(int x=0;x<width;x++){
      if(table[x+width*y]=='@'){
	targetList->AddItem(new Target(GOTO,x+1,y+1,0));
      }
      if(table[x+width*y]=='~'){
	isLethal=true;
      }

    }
   
  }
}
bool App::hasTarget(Target *new_t){
  for(int i=0;i<targetList->CountItems();i++){
    Target *t=(Target*)(targetList->ItemAt(i));
    if(t->hasSameTarget(new_t)){
      return true;
    }
  }
  return false;
}
void App::psychoKiller(){
  int realx=currentPlayer->x-1;
  int realy=currentPlayer->y-1;
  // scan to left
  bool cankill;int water_at; 
  char a_case;
  cankill=false;
  water_at=0;
 
  for(int i=realx+1;i<width;i++){
    a_case=table[i+realy*width];
    if(a_case=='~'){
      water_at=i;
      cankill=true;
      break;
    }
    if(a_case!='.' && a_case!='@'){
      cankill=false;
      break;
    }
  }
  if(cankill){
    printf("Can Push To Right\n");
   
    //find an enemy between realx and water_at
    for(int i=0;i<playerList->CountItems();i++){
      Player *p=(Player*)(playerList->ItemAt(i));
      if(p->y==currentPlayer->y && (p->x-1)>realx && (p->x-1)<water_at && p->id!=id){
	printf("Push To EAST\n");
	targetList->AddItem(new Target(PUSH_EAST,0,0,0),0);
	break;
      }
    }
  }
  // LEFT
  cankill=false;
  water_at=0;
  for(int i=realx-1;i>=0;i--){
    a_case=table[i+realy*width];
    if(a_case=='~'){
      water_at=i;
      cankill=true;
      break;
    }
    if(a_case!='.' && a_case!='@'){
      cankill=false;
      break;
    }
  }
  if(cankill){
    printf("Can Push To Left\n");
    
    //find an enemy between realx and water_at
    for(int i=0;i<playerList->CountItems();i++){
      Player *p=(Player*)(playerList->ItemAt(i));
      if(p->y==currentPlayer->y && (p->x-1)<realx && (p->x-1)>water_at && p->id!=id){
	printf("Push To WEST\n");
	targetList->AddItem(new Target(PUSH_WEST,0,0,0),0);
	break;
      }
    }
  }
 
  
  // NORTH
  cankill=false;
  water_at=0;
 
  for(int i=realy+1;i<height;i++){
    a_case=table[realx+i*width];
    if(a_case=='~'){
      water_at=i;
      cankill=true;
      break;
    }
    if(a_case!='.' && a_case!='@'){
      cankill=false;
      break;
    }
  }
  if(cankill){
    printf("Can Push To North\n");
    
    //find an enemy between realx and water_at
    for(int i=0;i<playerList->CountItems();i++){
      Player *p=(Player*)(playerList->ItemAt(i));
      if(p->x==currentPlayer->x && (p->y-1)>realy && (p->y-1)<water_at && p->id!=id ){
	printf("Push To Northt\n");
	targetList->AddItem(new Target(PUSH_NORTH,0,0,0),0);
	break;
      }
    }
  }
  // SOUTH
  cankill=false;
  water_at=0;
  for(int i=realy-1;i>=0;i--){
    a_case=table[realx+i*width];
    if(a_case=='~'){
      water_at=i;
      cankill=true;
      break;
    }
    if(a_case!='.' && a_case!='@'){
      cankill=false;
      break;
    }
  }
  if(cankill){
    printf("Can Push To South\n");
    
    //find an enemy between realx and water_at
    for(int i=0;i<playerList->CountItems();i++){
      Player *p=(Player*)(playerList->ItemAt(i));
      if(p->x==currentPlayer->x && (p->y-1)<realy && (p->y-1)>water_at && p->id!=id){
	printf("Push To South\n");
	targetList->AddItem(new Target(PUSH_SOUTH,0,0,0),0);
	break;
      }
    }
  }



}
