#ifndef	_APP_H
#define	_APP_H



#include <errno.h>
#include <string.h>
#include <sys/types.h>
#include <sys/socket.h>
#include <netinet/in.h>
#include <arpa/inet.h>
#include <netdb.h>

#include "PathFinder.h"
class Target;
class RList;
#include "Player.h"
class App
{
 public:
  CPathFinder Find; 
  int width,height;
  bool hack;
  Player *currentPlayer;
 
  int Valid(int x, int y, void *r){
    if (x < 0 || y < 0 || 
	x >= width || y >= height || current_table[x+y*width]=='~') 
      return 0; 
    return true;
  }
  int Cost(int x, int y, void *r){
    int cost;
    if(!Valid(x,y,r))
      return 3000;
    char t=current_table[x+y*width];
    if(t=='.' || t=='@'){
      cost=1;
      //printf("Cost:(%d,%d):%d\n",x,y,cost);
      return cost;
    }
    if(t=='+'){
      cost=4;
      return cost;
    }
    cost=2000;
    //printf("Cost:(%d,%d):%d\n",x,y,cost);
    return cost;
  }
  
 private:
  int sockfd;
  struct sockaddr_in their_addr; // connector's address information
  struct hostent *he;
  int id,capacity,money;
  bool isLethal;
 public:
  char *table,*current_table; 
  
  RList *playerList,*targetList;
  

 public:
  App();
  ~App();
  void Run();
  bool Init(char *hostname, unsigned short port);
  bool ReadPackage();
  bool SendReply();
  bool Send(char *buffer, int length);
  bool ReadServerReply();
  bool ParseServerReply(char* buffer,int length);
  bool ParsePackage(char* buffer,int length);

  void SetCurrent(int x,int y,char c);
  void PrintToStream();
  void UpdateTable();
  void FindTarget();
  bool hasTarget(Target *new_t);
  void psychoKiller();
};

extern App *be_app;
#endif
