#ifndef	_RLIST_H
#define	_RLIST_H

class RList {

public:
  RList(int itemsPerBlock = 20);
  RList(const RList&);
  virtual ~RList();
  RList	&operator=(const RList &from);
  
  /* Adding and removing items. */
  bool	AddItem(void *item);
  bool	AddItem(void *item, int atIndex);
  bool	AddList(RList *newItems);
  bool	AddList(RList *newItems, int atIndex);
  bool	RemoveItem(void *item);
  void	*RemoveItem(int index);
  bool	RemoveItems(int index, int count);
  bool	ReplaceItem(int index, void *newItem);
  void	MakeEmpty();
  
  /* Reordering items. */
  void	SortItems(int (*cmp)(const void *, const void *));
  bool	SwapItems(int indexA, int indexB);
  bool	MoveItem(int fromIndex, int toIndex);
  
  /* Retrieving items. */
  void	*ItemAt(int) const;
  void	*ItemAtFast(int) const;
  void	*FirstItem() const;
  void	*LastItem() const;
  void	*Items() const;
  
  /* Querying the list. */
  bool	HasItem(void *item) const;
  int	IndexOf(void *item) const;
  int	CountItems() const;
  bool	IsEmpty() const;
  
  /* Iterating over the list. */
  void	DoForEach(bool (*func)(void *));
  void	DoForEach(bool (*func)(void *, void *), void *);
  
  /*----- Private or reserved ---------------*/
 private:
 
  void	Resize(int count);
  
  void**	fObjectList;
  int	fPhysicalSize;
  
  int	fBlockSize;
  int	fItemCount;
 
};

/*-------------------------------------------------------------*/
/*-------------------------------------------------------------*/

#endif 
